"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var _ = require("underscore");
var icon_1 = require("./../display/icon");
var classNames_1 = require("../../utilities/classNames");
var TabControl = /** @class */ (function (_super) {
    tslib_1.__extends(TabControl, _super);
    function TabControl(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { selectedTabIndex: 0 };
        return _this;
    }
    TabControl.prototype.changeTab = function (newIndex) {
        var _this = this;
        this.setState({ selectedTabIndex: newIndex }, function () {
            if (_this.props.onTabChanged) {
                _this.props.onTabChanged(newIndex);
            }
        });
    };
    TabControl.prototype.componentWillMount = function () {
        if (this.props.defaultSelectedIndex !== undefined) {
            this.setState({ selectedTabIndex: this.props.defaultSelectedIndex });
        }
    };
    TabControl.prototype.render = function () {
        var _this = this;
        var attrs = _.omit(this.props, "className");
        var tabAlignment = this.props.tabAlignment;
        if (!tabAlignment) {
            tabAlignment = "left";
        }
        var classes = classNames_1.ClassHelpers.classNames(this.props.className, "tab-control", {
            "tabs-right": tabAlignment == "right",
            "tabs-left": tabAlignment == "left"
        });
        return (React.createElement("div", tslib_1.__assign({}, attrs, { className: classes }),
            React.createElement("div", { className: "tab-control-header" }, React.Children.map(this.props.children, function (c, i) {
                return React.createElement("div", { className: "tab-item-header" + (_this.state.selectedTabIndex === i ? ' selected' : ''), onClick: function () { return _this.changeTab(i); } },
                    c.props.icon ? React.createElement(icon_1.Icon, { className: "m-right-xsmall", icon: c.props.icon }) : null,
                    c.props.title);
            })),
            this.props.children[this.state.selectedTabIndex]));
    };
    return TabControl;
}(React.Component));
exports.TabControl = TabControl;
var TabItem = /** @class */ (function (_super) {
    tslib_1.__extends(TabItem, _super);
    function TabItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TabItem.prototype.render = function () {
        var attrs = _.omit(this.props, "className", "title");
        return React.createElement("div", tslib_1.__assign({}, attrs, { className: "tab-content" + (this.props.className ? " " + this.props.className : '') }), this.props.children);
    };
    return TabItem;
}(React.Component));
exports.TabItem = TabItem;
